/*
 * Gv4l's crontab stuff
 * Create, Delete, Enable, Disable crontab entries
 * 
 * Author:	Todor T. Zviskov (a.k.a. Warder) - http://warder.ath.cx:81/
 * License:	GPL-2 - http://www.gnu.org/licenses/gpl.txt
 *
 * (C)2002-2004 Todor T. Zviskov.
 */


#ifdef HAVE_CONFIG_H
	#include <config.h>
#endif

#include <gnome.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "gv4l.h"
#include "interface.h"
#include "support.h"

extern GtkWidget *gv4l;		//is initialized in main.c
extern char config_file[250];	//config file variable from main.c
extern gboolean record;		//record on startup var from main.c
extern gint visible[3];		//window visibility

GtkWidget *schedule;
gchar sch_file[250] = "/tmp/gv4l-schedule";	//the schedule file
//used in deletion confirmation box
char delete[500];




//show the schedule manager
void on_schedule_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	on_schedule_clicked ((GtkButton *) menuitem, menuitem);
}



//show the schedule manager
void on_schedule_clicked (GtkButton * button, gpointer user_data)
{
	gchar home[250];
	gchar tmp_file[250];	//temp file
	gchar config[250];		//config file
	gchar command[250];		//command to be written
	gint i;

	//GtkWidget *schedule;
	GtkWidget *cmd;
	//GtkWidget *wdsp;

	//call auto file extension
	//on_combo_entry1_focus_out_event ((GtkWidget *) button, NULL, button);

	//create window
	if (visible[2] == 1)
		return;
	schedule = create_schedule ();
	gtk_widget_show (schedule);
	visible[2] = 1;

	//lookup widget after it is created
	cmd = lookup_widget (schedule, "txtCmd");
	//wdsp = lookup_widget (schedule, "txtDisplay");

	strcpy (home, g_get_home_dir ());	//copy home dir value

	//set the default schedule file
	strcpy (sch_file, home);
	strcat (sch_file, "/.gv4l2/cron/schedule");
	//see if we have to create non-default schedule file
	if (fopen (sch_file, "r"))
	{
		for (i = 1; i < 10000; i++)
		{
			sprintf (tmp_file, "%s-%d", sch_file, i);
			if (fopen (tmp_file, "r") == NULL)
			{
				strcpy (sch_file, tmp_file);
				i = 10000;
			}
		}
	}

	//store config file to other variable
	strcpy (config, config_file);
	//set the schedule file as config file
	strcpy (config_file, sch_file);
	//run program init function
	on_save_settings1_activate ((GtkMenuItem *) button, button);
	//restore config file value
	strcpy (config_file, config);

	//write the command to the appropriate textbox
	sprintf (command, "gv4l --file %s --record", sch_file);
	gtk_entry_set_text (GTK_ENTRY (cmd), command);
	//gtk_entry_set_text (GTK_ENTRY (wdsp), g_getenv ("DISPLAY"));
}






//close the schedule manager
void on_btnClose_clicked (GtkButton * button, gpointer user_data)
{
	//vars
	FILE *inFile;
	gchar cron_line[500];
	gchar schfile[500];
	GtkWidget *schedule = lookup_widget (GTK_WIDGET (button), "schedule");

	strcpy (schfile, sch_file);
	//make sure we got " " after the filename in cron
	strcat (schfile, " ");
	//put cron to temp file
	system ("crontab -l > /tmp/gv4l-cron");
	inFile = fopen ("/tmp/gv4l-cron", "r");
	do
	{
		strcpy (cron_line, "unknown");
		fgets (cron_line, 500, inFile);

		//preserve schedule file if found in cron
		if (strstr (cron_line, schfile))
			strcpy (sch_file, "/tmp/gv4l_needs_this_file");
		//remove schedule file if not on cron
		if (feof (inFile) != 0)
			remove (sch_file);
	}
	while (feof (inFile) == 0);

	fclose (inFile);
	remove ("/tmp/gv4l-cron");

	//close window
	gtk_widget_destroy (schedule);
	visible[2] = 0;
}

//make sure we don't have useless schedules
gboolean on_schedule_delete_event (GtkWidget * widget,
									GdkEvent * event, gpointer user_data)
{
	on_btnClose_clicked ((GtkButton *) widget, widget);
	return FALSE;
}



//scheduler weekdays selection
//disable select all
void on_chkMon_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllDays = lookup_widget (GTK_WIDGET (button), "chkAllDays");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllDays), FALSE);
}

//disable select all
void on_chkTue_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllDays = lookup_widget (GTK_WIDGET (button), "chkAllDays");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllDays), FALSE);
}

//disable select all
void on_chkWed_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllDays = lookup_widget (GTK_WIDGET (button), "chkAllDays");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllDays), FALSE);
}

//disable select all
void on_chkThu_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllDays = lookup_widget (GTK_WIDGET (button), "chkAllDays");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllDays), FALSE);
}

//disable select all
void on_chkFri_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllDays = lookup_widget (GTK_WIDGET (button), "chkAllDays");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllDays), FALSE);
}

//disable select all
void on_chkSat_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllDays = lookup_widget (GTK_WIDGET (button), "chkAllDays");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllDays), FALSE);
}

//disable select all
void on_chkSun_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllDays = lookup_widget (GTK_WIDGET (button), "chkAllDays");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllDays), FALSE);
}

//disable individual weekdays and enable select all
void on_chkAllDays_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *Mon = lookup_widget (GTK_WIDGET (button), "chkMon");
	GtkWidget *Tue = lookup_widget (GTK_WIDGET (button), "chkTue");
	GtkWidget *Wed = lookup_widget (GTK_WIDGET (button), "chkWed");
	GtkWidget *Thu = lookup_widget (GTK_WIDGET (button), "chkThu");
	GtkWidget *Fri = lookup_widget (GTK_WIDGET (button), "chkFri");
	GtkWidget *Sat = lookup_widget (GTK_WIDGET (button), "chkSat");
	GtkWidget *Sun = lookup_widget (GTK_WIDGET (button), "chkSun");

	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Mon), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Tue), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Wed), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Thu), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Fri), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Sat), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Sun), FALSE);
}



//scheduler months selection
//disable select all
void on_chkJan_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void on_chkJul_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void on_chkFeb_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void on_chkAug_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void on_chkMar_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void on_chkSep_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void on_chkApr_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void on_chkOct_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void on_chkMay_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void on_chkNov_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void on_chkJun_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable select all
void on_chkDec_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *AllMths = lookup_widget (GTK_WIDGET (button), "chkAllMths");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (AllMths), FALSE);
}

//disable individual months and enable select all
void on_chkAllMths_pressed (GtkButton * button, gpointer user_data)
{
	GtkWidget *Jan = lookup_widget (GTK_WIDGET (button), "chkJan");
	GtkWidget *Feb = lookup_widget (GTK_WIDGET (button), "chkFeb");
	GtkWidget *Mar = lookup_widget (GTK_WIDGET (button), "chkMar");
	GtkWidget *Apr = lookup_widget (GTK_WIDGET (button), "chkApr");
	GtkWidget *May = lookup_widget (GTK_WIDGET (button), "chkMay");
	GtkWidget *Jun = lookup_widget (GTK_WIDGET (button), "chkJun");
	GtkWidget *Jul = lookup_widget (GTK_WIDGET (button), "chkJul");
	GtkWidget *Aug = lookup_widget (GTK_WIDGET (button), "chkAug");
	GtkWidget *Sep = lookup_widget (GTK_WIDGET (button), "chkSep");
	GtkWidget *Oct = lookup_widget (GTK_WIDGET (button), "chkOct");
	GtkWidget *Nov = lookup_widget (GTK_WIDGET (button), "chkNov");
	GtkWidget *Dec = lookup_widget (GTK_WIDGET (button), "chkDec");

	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Jan), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Feb), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Mar), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Apr), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (May), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Jun), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Jul), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Aug), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Sep), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Oct), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Nov), FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (Dec), FALSE);
}





//create new cron job
void on_btnCreate_clicked (GtkButton * button, gpointer user_data)
{
	gchar cron_job[500];
	int display;

	gchar month[250] = "", wkday[250] = "";
	gchar ttl[250], hr[250], min[250], day[250], cmd[250], dsp[250];
	gboolean jan, feb, mar, apr, may, jun, jul, aug, sep, oct, nov, dec,
				mon, tue, wed, thu, fri, sat, sun;
	//lookup widgets
	GtkWidget *wttl = lookup_widget (GTK_WIDGET (button), "txtTitle");
	GtkWidget *whr = lookup_widget (GTK_WIDGET (button), "cbohrs");
	GtkWidget *wmin = lookup_widget (GTK_WIDGET (button), "cbomins");
	GtkWidget *wday = lookup_widget (GTK_WIDGET (button), "cboday");
	GtkWidget *wjan = lookup_widget (GTK_WIDGET (button), "chkJan");
	GtkWidget *wfeb = lookup_widget (GTK_WIDGET (button), "chkFeb");
	GtkWidget *wmar = lookup_widget (GTK_WIDGET (button), "chkMar");
	GtkWidget *wapr = lookup_widget (GTK_WIDGET (button), "chkApr");
	GtkWidget *wmay = lookup_widget (GTK_WIDGET (button), "chkMay");
	GtkWidget *wjun = lookup_widget (GTK_WIDGET (button), "chkJun");
	GtkWidget *wjul = lookup_widget (GTK_WIDGET (button), "chkJul");
	GtkWidget *waug = lookup_widget (GTK_WIDGET (button), "chkAug");
	GtkWidget *wsep = lookup_widget (GTK_WIDGET (button), "chkSep");
	GtkWidget *woct = lookup_widget (GTK_WIDGET (button), "chkOct");
	GtkWidget *wnov = lookup_widget (GTK_WIDGET (button), "chkNov");
	GtkWidget *wdec = lookup_widget (GTK_WIDGET (button), "chkDec");
	GtkWidget *wMon = lookup_widget (GTK_WIDGET (button), "chkMon");
	GtkWidget *wTue = lookup_widget (GTK_WIDGET (button), "chkTue");
	GtkWidget *wWed = lookup_widget (GTK_WIDGET (button), "chkWed");
	GtkWidget *wThu = lookup_widget (GTK_WIDGET (button), "chkThu");
	GtkWidget *wFri = lookup_widget (GTK_WIDGET (button), "chkFri");
	GtkWidget *wSat = lookup_widget (GTK_WIDGET (button), "chkSat");
	GtkWidget *wSun = lookup_widget (GTK_WIDGET (button), "chkSun");
	GtkWidget *wcmd = lookup_widget (GTK_WIDGET (button), "txtCmd");
	GtkWidget *wdsp = lookup_widget (GTK_WIDGET (button), "txtDisplay");

	//get variables
	strncpy (ttl, gtk_entry_get_text (GTK_ENTRY (wttl)), 250);
	strncpy (hr, gtk_entry_get_text (GTK_ENTRY (whr)), 250);
	strncpy (min, gtk_entry_get_text (GTK_ENTRY (wmin)), 250);
	strncpy (day, gtk_entry_get_text (GTK_ENTRY (wday)), 250);
	jan = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wjan));
	feb = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wfeb));
	mar = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wmar));
	apr = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wapr));
	may = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wmay));
	jun = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wjun));
	jul = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wjul));
	aug = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (waug));
	sep = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wsep));
	oct = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (woct));
	nov = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wnov));
	dec = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wdec));
	mon = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wMon));
	tue = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wTue));
	wed = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wWed));
	thu = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wThu));
	fri = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wFri));
	sat = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wSat));
	sun = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wSun));
	strncpy (cmd, gtk_entry_get_text (GTK_ENTRY (wcmd)), 250);
	strncpy (dsp, gtk_entry_get_text (GTK_ENTRY (wdsp)), 250);


	//see what months are selected
	if (jan == TRUE && strcmp (month, "") == 0)
		strcpy (month, "1");
	else if (jan == TRUE)
		strcat (month, ",1");

	if (feb == TRUE && strcmp (month, "") == 0)
		strcpy (month, "2");
	else if (feb == TRUE)
		strcat (month, ",2");

	if (mar == TRUE && strcmp (month, "") == 0)
		strcpy (month, "3");
	else if (mar == TRUE)
		strcat (month, ",3");

	if (apr == TRUE && strcmp (month, "") == 0)
		strcpy (month, "4");
	else if (apr == TRUE)
		strcat (month, ",4");

	if (may == TRUE && strcmp (month, "") == 0)
		strcpy (month, "5");
	else if (may == TRUE)
		strcat (month, ",5");

	if (jun == TRUE && strcmp (month, "") == 0)
		strcpy (month, "6");
	else if (jun == TRUE)
		strcat (month, ",6");

	if (jul == TRUE && strcmp (month, "") == 0)
		strcpy (month, "7");
	else if (jul == TRUE)
		strcat (month, ",7");

	if (aug == TRUE && strcmp (month, "") == 0)
		strcpy (month, "8");
	else if (aug == TRUE)
		strcat (month, ",8");

	if (sep == TRUE && strcmp (month, "") == 0)
		strcpy (month, "9");
	else if (sep == TRUE)
		strcat (month, ",9");

	if (oct == TRUE && strcmp (month, "") == 0)
		strcpy (month, "10");
	else if (oct == TRUE)
		strcat (month, ",10");

	if (nov == TRUE && strcmp (month, "") == 0)
		strcpy (month, "11");
	else if (nov == TRUE)
		strcat (month, ",11");

	if (dec == TRUE && strcmp (month, "") == 0)
		strcpy (month, "12");
	else if (dec == TRUE)
		strcat (month, ",12");

	if (strcmp (month, "") == 0
		|| strcmp (month, "1,2,3,4,5,6,7,8,9,10,11,12") == 0)
		strcpy (month, "*");



	//see what days are selected
	if (mon == TRUE && strcmp (wkday, "") == 0)
		strcpy (wkday, "1");
	else if (mon == TRUE)
		strcat (wkday, ",1");

	if (tue == TRUE && strcmp (wkday, "") == 0)
		strcpy (wkday, "2");
	else if (tue == TRUE)
		strcat (wkday, ",2");

	if (wed == TRUE && strcmp (wkday, "") == 0)
		strcpy (wkday, "3");
	else if (wed == TRUE)
		strcat (wkday, ",3");

	if (thu == TRUE && strcmp (wkday, "") == 0)
		strcpy (wkday, "4");
	else if (thu == TRUE)
		strcat (wkday, ",4");

	if (fri == TRUE && strcmp (wkday, "") == 0)
		strcpy (wkday, "5");
	else if (fri == TRUE)
		strcat (wkday, ",5");

	if (sat == TRUE && strcmp (wkday, "") == 0)
		strcpy (wkday, "6");
	else if (sat == TRUE)
		strcat (wkday, ",6");

	if (sun == TRUE && strcmp (wkday, "") == 0)
		strcpy (wkday, "7");
	else if (sun == TRUE)
		strcat (wkday, ",7");

	if (strcmp (wkday, "") == 0 || strcmp (wkday, "1,2,3,4,5,6,7") == 0)
		strcpy (wkday, "*");


	//convert display value to integer value
	display = atoi (dsp);

	//create cron line
	sprintf (cron_job, "# %s\n%s\t%s\t%s\t%s\t%s\t%s\n\0", ttl, min, hr, day,
			 month, wkday, cmd);

	//call the cron update function
	update_cron ("create", cron_job, display);

	//refresh the list
	on_schedule_show ((GtkWidget *) button, button);
}



//load the cron list
void on_schedule_show (GtkWidget * widget, gpointer user_data)
{
	GtkWidget *treeview = lookup_widget (GTK_WIDGET (schedule), "treeview");
	GtkCellRenderer *render;
	GtkTreeModel *treemodel;
	/* Create the new Tree Store object, the arguments to the function
		 are the number of columns and the then the type of each column.
		 ie. two columns, both of type string */
	GtkTreeStore *treestore = gtk_tree_store_new (3, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_BOOLEAN);
	GtkTreeIter iter, parent, child;
	FILE *inFile;
	gchar cron_line[500];
	gchar enabled[500], disabled[500], value[500];
	gchar *pos;

	/* load the values in list */
	system ("crontab -l > /tmp/gv4l-cron-r");
	inFile = fopen ("/tmp/gv4l-cron-r", "r");
	while (feof (inFile) == 0)
	{
		strcpy (cron_line, "#");
		fgets (cron_line, 500, inFile);

		//get rid of newline char
		if (strstr (cron_line, "\n"))
		{
			pos = strstr (cron_line, "\n");
			strncpy (pos, "\0", 1);
		}

		strncpy (disabled, cron_line, 2);
		if (strstr (disabled, "#\\"))
		{
			strcpy (enabled, "NO");
			pos = cron_line + 2;
			sprintf (value, "%s", pos);
			gtk_tree_store_append (treestore, &parent, NULL);
			gtk_tree_store_set (treestore, &parent, VALUE, value, ENABLED,
								enabled, EDITABLE, TRUE, -1);
		}
		else if (strstr (disabled, "#"));
		else
		{
			strcpy (enabled, "YES");
			sprintf (value, "%s", cron_line);
			gtk_tree_store_append (treestore, &parent, NULL);
			gtk_tree_store_set (treestore, &parent, VALUE, value, ENABLED,
								enabled, EDITABLE, TRUE, -1);
		}
	}
	fclose (inFile);
	remove ("/tmp/gv4l-cron-r");



	/* return model */
	treemodel = GTK_TREE_MODEL (treestore);
	gtk_tree_view_set_model (GTK_TREE_VIEW (treeview),
				 				GTK_TREE_MODEL (treemodel));

	/* create columns only if they don't exist */
	if (!gtk_tree_view_get_columns (GTK_TREE_VIEW (treeview)))
	{
		render = gtk_cell_renderer_text_new ();
		//g_signal_connect (G_OBJECT(render), "edited", G_CALLBACK(lastname_edited), treemodel);
		gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
													 -1, "Enabled", render,
													 "text", ENABLED,
													 /*	"editable", EDITABLE, */
													 NULL);
		render = gtk_cell_renderer_text_new ();
		gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (treeview),
													 -1, "Value", render,
													 "text", VALUE, NULL);
	}

	/* Add the view widget to the window */
	//gtk_container_add (GTK_CONTAINER (schedule), treeview);

	/* Get a GtkTreeIter for the first node in the model */
	gtk_tree_model_get_iter_first (GTK_TREE_MODEL (treemodel), &iter);
}


//task enable requested
void on_enable_task_clicked (GtkButton * button, gpointer user_data)
{
	GtkWidget *treeview = lookup_widget (GTK_WIDGET (button), "treeview");
	GtkTreeModel *model;
	GtkTreeIter iter;
	if (!gtk_tree_selection_get_selected
		(gtk_tree_view_get_selection (GTK_TREE_VIEW (treeview)), &model, &iter))
	{
		GtkWidget *no_selection = create_no_selection ();
		gtk_widget_show (no_selection);
		gtk_window_set_transient_for (GTK_WINDOW (no_selection), GTK_WINDOW (schedule));
		return;
	}
	else
	{
		gchar *enabled;
		gchar *val;
		int i;
		gtk_tree_model_get (model, &iter, ENABLED, &enabled, -1);
		gtk_tree_model_get (model, &iter, VALUE, &val, -1);
		if (strstr (val, "DISPLAY=") || strstr (val, "PATH="))
		{
			GtkWidget *variables = create_variables ();
			gtk_widget_show (variables);
			gtk_window_set_transient_for (GTK_WINDOW (variables), GTK_WINDOW (schedule));
			return;
		}

		if (strcmp (enabled, "YES") == 0)
			return;
		else
			update_cron ("enable", val, 0);
		//refresh the list
		on_schedule_show ((GtkWidget *) button, button);
		g_free (enabled);
		g_free (val);
	}
}


//task disable requested
void on_disable_task_clicked (GtkButton * button, gpointer user_data)
{
	GtkWidget *treeview = lookup_widget (GTK_WIDGET (button), "treeview");
	GtkTreeModel *model;
	GtkTreeIter iter;
	if (!gtk_tree_selection_get_selected
		(gtk_tree_view_get_selection (GTK_TREE_VIEW (treeview)), &model, &iter))
	{
		GtkWidget *no_selection = create_no_selection ();
		gtk_widget_show (no_selection);
		gtk_window_set_transient_for (GTK_WINDOW (no_selection), GTK_WINDOW (schedule));
		return;
	}
	else
	{
		gchar *enabled;
		gchar *val;
		gtk_tree_model_get (model, &iter, ENABLED, &enabled, -1);
		gtk_tree_model_get (model, &iter, VALUE, &val, -1);
		if (strstr (val, "DISPLAY=") || strstr (val, "PATH="))
		{
			GtkWidget *variables = create_variables ();
			gtk_widget_show (variables);
			gtk_window_set_transient_for (GTK_WINDOW (variables), GTK_WINDOW (schedule));
			return;
		}

		if (strcmp (enabled, "NO") == 0)
			return;
		else
			update_cron ("disable", val, 0);
		//refresh the list
		on_schedule_show ((GtkWidget *) button, button);
		g_free (enabled);
		g_free (val);
	}
}


//task deletion requested
void on_delete_task_clicked (GtkButton * button, gpointer user_data)
{
	GtkWidget *treeview = lookup_widget (GTK_WIDGET (button), "treeview");
	GtkTreeModel *model;
	GtkTreeIter iter;
	if (!gtk_tree_selection_get_selected
		(gtk_tree_view_get_selection (GTK_TREE_VIEW (treeview)), &model, &iter))
	{
		GtkWidget *no_selection = create_no_selection ();
		gtk_widget_show (no_selection);
		gtk_window_set_transient_for (GTK_WINDOW (no_selection), GTK_WINDOW (schedule));
		return;
	}
	else
	{
		GtkWidget *del = create_delete_task ();
		gchar *enabled;
		gchar *val;
		gtk_tree_model_get (model, &iter, VALUE, &val, -1);
		if (strstr (val, "DISPLAY=") || strstr (val, "PATH="))
		{
			GtkWidget *variables = create_variables ();
			gtk_widget_show (variables);
			gtk_window_set_transient_for (GTK_WINDOW (variables), GTK_WINDOW (schedule));
			return;
		}

		strcpy (delete, val);
		gtk_widget_show (del);
		gtk_window_set_transient_for (GTK_WINDOW (del), GTK_WINDOW (schedule));
		g_free (val);
	}
}


//proceed with task removal
void on_delete_task_yes_clicked (GtkButton * button, gpointer user_data)
{
	GtkWidget *del = lookup_widget (GTK_WIDGET (button), "delete_task");
	update_cron ("delete", delete, 0);
	delete[0] = '\0';
	//refresh the list
	on_schedule_show ((GtkWidget *) button, button);
	gtk_widget_destroy (del);
}


//stop task deletion
void on_delete_task_no_clicked (GtkButton * button, gpointer user_data)
{
	GtkWidget *del = lookup_widget (GTK_WIDGET (button), "delete_task");
	gtk_widget_destroy (del);
}


//update/create task
void update_cron (char action[20], char cron_job[500], int display)
{
	FILE *outFile;
	FILE *inFile;
	gchar cron_line[500], cron_tit[500] = "", disabled[500] = "";
	int fnd_dis = 0;
	int fnd_path = 0;

	//read crontab
	system ("crontab -l > /tmp/gv4l-cron");

	//perform the cron update
	inFile = fopen ("/tmp/gv4l-cron", "r");
	outFile = fopen ("/tmp/gv4l-cron-new", "w");

	while (feof (inFile) == 0)
	{
		cron_line[0] = '\0';
		fgets (cron_line, 500, inFile);
		if (feof (inFile))
		{
			if (fnd_dis == 0)
			{
				sprintf (cron_line, "# X display variable\nDISPLAY=\":%d.0\"\n", display);
				fputs (cron_line, outFile);
			}
			break;
		}
		cron_line[499] = '\0';

		//see if we have to enable, disable, or delete
		if (strstr (cron_line, cron_job))
		{
			//if (strstr (action, "create"))
			//sprintf (action, "no-create-exists");
			if (strstr (action, "delete"))
				cron_line[0] = '\0';
			else
				fputs (cron_tit, outFile);
			if (strstr (action, "enable"))
				fprintf (outFile, "%s\n", cron_job);
			if (strstr (action, "disable"))
				fprintf (outFile, "#\\%s\n", cron_job);
			cron_line[0] = '\0';
			cron_tit[0] = '\0';
			//continue;
		}

		//check if we got DISPLAY variable
		if (strstr (cron_line, "DISPLAY="))
		{
			//change $DISPLAY only when we create task
			if (strstr (action, "create"))
			{
				sprintf (cron_line, "# X display variable\nDISPLAY=\":%d.0\"\n", display);
				fputs (cron_line, outFile);
			}
			fnd_dis = 1;
		}

		//check if we got PATH variable
		if (strstr (cron_line, "PATH="))
			fnd_path = 1;

		//see if we got disabled task, comment or title
		strncpy (disabled, cron_line, 2);
		if (strstr (disabled, "#\\"))
		{
			fputs (cron_tit, outFile);
			//strcpy (cron_tit, "");
			cron_tit[0] = '\0';
			fputs (cron_line, outFile);
		}
		else if (strstr (disabled, "#"))
			strcpy (cron_tit, cron_line);
		else
		{
			fputs (cron_tit, outFile);
			//strcpy (cron_tit, "");
			cron_tit[0] = '\0';
			fputs (cron_line, outFile);
		}
	}

	fclose (inFile);
	fclose (outFile);

	//get the user's PATH and put in cron
	if (fnd_path == 0)
	{
		system ("echo \"# PATH variable for cron\" >> /tmp/gv4l-cron-new");
		system ("echo \"PATH=$PATH\" >> /tmp/gv4l-cron-new");
	}

	outFile = fopen ("/tmp/gv4l-cron-new", "a");
	//create a task
	if (strcmp (action, "create") == 0)
		fputs (cron_job, outFile);
	fclose (outFile);

	//install new cron
	system ("crontab /tmp/gv4l-cron-new");
	remove ("/tmp/gv4l-cron-new");
	remove ("/tmp/gv4l-cron");
}
