/*
 * Gv4l's stuff
 * Initialize, FPS, Norm, Audio & Video, Player, Settings, Preferences functions
 * 
 * Author:	Todor T. Zviskov (a.k.a. Warder) - http://warder.ath.cx:81/
 * License:	GPL-2 - http://www.gnu.org/licenses/gpl.txt
 *
 * (C)2002-2004 Todor T. Zviskov.
 */


#ifdef HAVE_CONFIG_H
	#include <config.h>
#endif

#include <gnome.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>		//***//

#include "gv4l.h"
#include "interface.h"
#include "support.h"


#include <fcntl.h>
#include <sys/ioctl.h>
#include <linux/videodev.h>

#define	VIDEO_MODE_PAL_Nc	3
#define	VIDEO_MODE_PAL_M	4
#define	VIDEO_MODE_PAL_N	5
#define	VIDEO_MODE_NTSC_JP	6
#define	VIDEO_MODE_PAL_60	7


extern GtkWidget *gv4l;		//is initialized in main.c
extern char config_file[250];	//config file variable from main.c
extern gboolean record;		//record on startup var from main.c
extern GtkWidget *pref;		//prefs window

gchar arec_val[250] = "";	//recording source value
gint visible[3] = { 0, 0, 0 };	//window visibility
gchar v4l_info[9][255];
gint scrsaver = 0;
gint resume = 1;
gint save_exit = 0;
gchar temp[250] = "", temp1[10];


//execute on startup
void on_gv4l_show (GtkWidget * widget, gpointer user_data)
{

	//variables definition
	FILE *inFile;
	FILE *outFile;

	gchar home[250];		// = g_get_home_dir();
	gchar xawtv[250];
	gchar player[250] = "";
	gchar split_val[250] = "0";
	gchar rec_dur[250] = "";

	gchar conf_line[250] = "";
	gchar *pos;

	gchar vdev_val[250] = "", temp[250] = "";
	gchar vid_val[9][250], aud_val[10][250], mix_val[10][250];
	gchar adev_val[250] = "";
	gchar p_size[250] = "";
	gchar fps_val[250] = "";
	gchar cod_val[250] = "";
	gchar src_val[250] = "default_unknown";
	gchar chan_val[250] = "";
	gchar file_val[250] = "";
	gchar vbit_val[250] = "";
	gchar abit_val[250] = "";
	gchar agn_val[250] = "";
	gchar amix_val[250] = "/dev/mixer";
	gchar norm_val[10] = "NTSC";
	gint deinter;
	gint prev_val;
	gint yuv_val;
	gint i = 0;

	//lookup the widgets
	GtkWidget *vdev = lookup_widget (GTK_WIDGET (widget), "vdev_val");
	GtkWidget *adev = lookup_widget (GTK_WIDGET (widget), "adev_val");
	GtkWidget *size = lookup_widget (GTK_WIDGET (widget), "p_size");
	GtkWidget *fps = lookup_widget (GTK_WIDGET (widget), "fps_val");
	GtkWidget *cod = lookup_widget (GTK_WIDGET (widget), "combo_entry1");
	GtkWidget *src = lookup_widget (GTK_WIDGET (widget), "src_val");
	GtkWidget *chan = lookup_widget (GTK_WIDGET (widget), "chan_val");
	GtkWidget *file = lookup_widget (GTK_WIDGET (widget), "file_val");
	GtkWidget *vbit = lookup_widget (GTK_WIDGET (widget), "vbit_val");
	GtkWidget *abit = lookup_widget (GTK_WIDGET (widget), "abit_val");
	GtkWidget *agn = lookup_widget (GTK_WIDGET (widget), "agn_val");
	GtkWidget *prev = lookup_widget (GTK_WIDGET (widget), "prev_val");
	GtkWidget *inter = lookup_widget (GTK_WIDGET (widget), "de_inter");
	GtkWidget *yuv = lookup_widget (GTK_WIDGET (widget), "yuv_val");
	GtkWidget *rec = lookup_widget (GTK_WIDGET (widget), "recTime");
	GtkWidget *status = lookup_widget (GTK_WIDGET (widget), "status");
	GtkWidget *norm = lookup_widget (GTK_WIDGET (widget), "norm_val");
	GtkWidget *amix = lookup_widget (GTK_WIDGET (widget), "amix_val");

	GtkWidget *vdev_cbo = lookup_widget (GTK_WIDGET (widget), "vdev_cbo");
	GtkWidget *adev_cbo = lookup_widget (GTK_WIDGET (widget), "adev_cbo");
	GtkWidget *amix_cbo = lookup_widget (GTK_WIDGET (widget), "amix_cbo");
	GtkWidget *chan_cbo = lookup_widget (GTK_WIDGET (widget), "chan_cbo");

	GtkWidget *split = lookup_widget (GTK_WIDGET (pref), "split_val");
	GtkWidget *vid_player = lookup_widget (GTK_WIDGET (pref), "vid_player");

	GList *vid_lst = NULL, *aud_lst = NULL, *mix_lst = NULL;

	GtkStyle *style = gtk_style_new ();
	//set the status color
	GdkColor green = { 0, 0, 35335, 0 };


	strcpy (home, g_get_home_dir ());	//copy home dir value
	system ("rm -rf /tmp/player-gv4l");	//remove temp file

	//see if we got xawtv configuration file
	strcpy (xawtv, home);
	strcat (xawtv, "/.xawtv");
	if ((inFile = fopen (xawtv, "r")) == NULL)
	{
		GtkWidget *no_xawtv;
		GList *chan_lst = NULL;
		chan_lst = g_list_append (chan_lst, "0\0");
		gtk_combo_set_popdown_strings (GTK_COMBO (chan_cbo), chan_lst);
		g_list_free (chan_lst);
		
		no_xawtv = create_no_xawtv ();
		gtk_widget_show (no_xawtv);
		gtk_window_set_transient_for (GTK_WINDOW (no_xawtv), GTK_WINDOW (gv4l));
	}
	else
	{
		gchar ch_val[1000][100], ch[1];
		GList *chan_lst = NULL;
		gint i = 0;
		//set first one to 0 as field is now locked
		strcpy (ch_val[i], "0\0");
		chan_lst = g_list_append (chan_lst, ch_val[i]);
		i++;
		while (i != 1000)
		{
			fgets (conf_line, 250, inFile);
			if (feof (inFile))
				break;

			strncpy (ch, conf_line, 1);
			if (strchr (conf_line, '[') && (!strchr (ch, '#')))
			{
				pos = strrchr (conf_line, ']');
				strncpy (pos, "\0", 1);
				pos = strstr (conf_line, "[") + 1;
				sprintf (ch_val[i], "%s", pos);
				fgets (conf_line, 250, inFile);
				if (feof (inFile))
					break;
				strncpy (ch, conf_line, 1);
				if (strstr (conf_line, "channel") && (!strchr (ch, '#')))
				{
					if (strstr (ch_val[i], "\""))
					{
						pos = strstr (conf_line, "\n");
						strncpy (pos, "\0", 1);
						pos = strstr (conf_line, "=") + 1;
						sprintf (ch_val[i], "%s", pos);
						strncpy (ch, ch_val[i], 1);
						while (strchr (ch, ' '))
						{
							pos += 1;
							sprintf (ch_val[i], "%s", pos);
							strncpy (ch, ch_val[i], 1);
						}
					}
					chan_lst = g_list_append (chan_lst, ch_val[i]);
					i++;
				}
				else
					strncpy (ch_val[i], "\0", 1);
			}
		}
		fclose (inFile);
		gtk_combo_set_popdown_strings (GTK_COMBO (chan_cbo), chan_lst);
		g_list_free (chan_lst);
	}

	//make sure we have the directories created
	chdir (home);
	mkdir (".gv4l2", S_IRUSR | S_IWUSR | S_IXUSR);
	mkdir (".gv4l2/cron", S_IRUSR | S_IWUSR | S_IXUSR);
	mkdir (".gv4l2/tmp", S_IRUSR | S_IWUSR | S_IXUSR);
	mkdir ("videos", S_IRUSR | S_IWUSR | S_IXUSR);

	//check for old config files to convert
	if (fopen (".gv4l2/config", "r") == NULL && fopen (".gv4l", "r") != NULL)
		system ("xterm -e \"echo 'Gv4l will start after the convertion.';gv4l-convert.sh\"");
	//load the configuration from file (if exists)
	if (fopen (config_file, "r") != NULL)
	{
		inFile = fopen (config_file, "r");
		/* fscanf (inFile, "%s%s%s%s%s%s%s%s%s%s%d%s%s%s", vdev_val, adev_val,
		p_size, fps_val, cod_val, vbit_val, abit_val, agn_val, chan_val,
		file_val, &prev_val, player, deinter, rec_dur);
		*/
		while (feof (inFile) == 0)
		{
			int i = 0;

			fgets (conf_line, 250, inFile);
			if (feof (inFile))
				break;
			if (strstr (conf_line, "="))
			{
				pos = strstr (conf_line, "\n");
				strncpy (pos, "\0", 1);
				pos = strstr (conf_line, "=") + 1;
				while (conf_line[i] && i < (strlen (conf_line) - strlen (pos)))
				{
					conf_line[i] = tolower (conf_line[i]);
					i++;
				}
			}

			if (strstr (conf_line, "videodev="))
				strcpy (vdev_val, pos);
			if (strstr (conf_line, "audiodev="))
				strcpy (adev_val, pos);
			if (strstr (conf_line, "picsize="))
				strcpy (p_size, pos);
			if (strstr (conf_line, "fps="))
				strcpy (fps_val, pos);
			if (strstr (conf_line, "codec="))
				strcpy (cod_val, pos);
			if (strstr (conf_line, "vbitrate="))
				strcpy (vbit_val, pos);
			if (strstr (conf_line, "abitrate="))
				strcpy (abit_val, pos);
			if (strstr (conf_line, "again="))
				strcpy (agn_val, pos);
			if (strstr (conf_line, "source="))
				strcpy (src_val, pos);
			if (strstr (conf_line, "channel="))
				strcpy (chan_val, pos);
			if (strstr (conf_line, "file="))
				strcpy (file_val, pos);
			if (strstr (conf_line, "preview="))
				prev_val = atoi (pos);
			if (strstr (conf_line, "player="))
				strcpy (player, pos);
			if (strstr (conf_line, "deinter="))
				deinter = atoi (pos);
			if (strstr (conf_line, "yuv="))
				yuv_val = atoi (pos);
			if (strstr (conf_line, "duration="))
				strcpy (rec_dur, pos);
			if (strstr (conf_line, "standard="))
				strcpy (norm_val, pos);
			if (strstr (conf_line, "mixer="))
				strcpy (amix_val, pos);
			if (strstr (conf_line, "audiosrc="))
				strcpy (arec_val, pos);
			if (strstr (conf_line, "screensaver"))
				scrsaver = atoi (pos);
			if (strstr (conf_line, "resume"))
				resume = atoi (pos);
			if (strstr (conf_line, "saveonexit"))
				save_exit = atoi (pos);
			if (strstr (conf_line, "split="))
				strcpy (split_val, pos);
		}
		fclose (inFile);

	}
	else				//set defaults
	{
		//strcpy (vdev_val, "/dev/video0");
		strcpy (adev_val, "/dev/dsp");
		strcpy (p_size, "384x288");
		strcpy (fps_val, "29.970");
		strcpy (cod_val, "xvid");
		strcpy (vbit_val, "1800,250,100");
		strcpy (abit_val, "96,0,5");
		strcpy (agn_val, "5");
		//strcpy (src_val, "0");
		strcpy (chan_val, "0");
		strcpy (norm_val, "NTSC");

		strcpy (file_val, home);
		strcat (file_val, "/videos/video.avi");

		prev_val = 1;
		deinter = 0;
		yuv_val = 0;
		//system ("echo none > /tmp/player-gv4l");
	}

	//load the values
	gtk_entry_set_text (GTK_ENTRY (vdev), "");
	for (i = 0; i < 9; i++)
	{
		sprintf (vid_val[i], "/dev/video%d", i);
		if ((inFile = fopen (vid_val[i], "r")) != NULL)
		{
			vid_lst = g_list_append (vid_lst, vid_val[i]);
			fclose (inFile);
			get_v4l_info (vid_val[i], i);
		}
	}
	gtk_combo_set_popdown_strings (GTK_COMBO (vdev_cbo), vid_lst);
	if (strcmp (vdev_val, "") != 0)
		gtk_entry_set_text (GTK_ENTRY (vdev), vdev_val);

	if ((inFile = fopen ("/dev/dsp", "r")) != NULL)
	{
		aud_lst = g_list_append (aud_lst, "/dev/dsp");
		fclose (inFile);
	}
	for (i = 0; i < 10; i++)
	{
		sprintf (aud_val[i], "/dev/dsp%d", i);
		if ((inFile = fopen (aud_val[i], "r")) != NULL)
		{
			aud_lst = g_list_append (aud_lst, aud_val[i]);
			fclose (inFile);
		}
	}
	gtk_combo_set_popdown_strings (GTK_COMBO (adev_cbo), aud_lst);
	if (strcmp (adev_val, "") != 0)
		gtk_entry_set_text (GTK_ENTRY (adev), adev_val);


	if ((inFile = fopen ("/dev/mixer", "r")) != NULL)
	{
		mix_lst = g_list_append (mix_lst, "/dev/mixer");
		fclose (inFile);
	}
	for (i = 0; i < 10; i++)
	{
		sprintf (mix_val[i], "/dev/mixer%d", i);
		if ((inFile = fopen (mix_val[i], "r")) != NULL)
		{
			mix_lst = g_list_append (mix_lst, mix_val[i]);
			fclose (inFile);
		}
	}
	gtk_combo_set_popdown_strings (GTK_COMBO (amix_cbo), mix_lst);
	gtk_entry_set_text (GTK_ENTRY (amix), amix_val);

	//add the available recording sources
	on_amix_val_changed ((GtkEditable *) widget, widget);

	gtk_entry_set_text (GTK_ENTRY (size), p_size);
	gtk_entry_set_text (GTK_ENTRY (fps), fps_val);
	gtk_entry_set_text (GTK_ENTRY (cod), cod_val);

	for (i = 0; i <= 9; i++)
	{
		sprintf (temp, "=%s\0", src_val);
		if (strstr (v4l_info[i], vdev_val) && strstr (v4l_info[i], temp))
			gtk_entry_set_text (GTK_ENTRY (src), src_val);
	}

	gtk_entry_set_text (GTK_ENTRY (chan), chan_val);
	gtk_entry_set_text (GTK_ENTRY (file), file_val);
	gtk_entry_set_text (GTK_ENTRY (vbit), vbit_val);
	gtk_entry_set_text (GTK_ENTRY (abit), abit_val);
	gtk_entry_set_text (GTK_ENTRY (agn), agn_val);
	gtk_entry_set_text (GTK_ENTRY (norm), norm_val);
	if (deinter == 1)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (inter), TRUE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (inter), FALSE);
	
	if (!strcmp (rec_dur, "\0"))
		strcpy (rec_dur, "0\0");
	gtk_entry_set_text (GTK_ENTRY (rec), rec_dur);
	
	if (prev_val == 1)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (prev), TRUE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (prev), FALSE);
	if (yuv_val == 1)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (yuv), TRUE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (yuv), FALSE);
	if (scrsaver == 0)
		system ("xscreensaver-command -exit >/dev/null 2>&1 &");

	gtk_entry_set_text (GTK_ENTRY (split), split_val);
	gtk_entry_set_text (GTK_ENTRY (vid_player), player);
	
	//set Idle status
	if (fopen ("/tmp/trr", "r") == NULL)
	{
		style->text[GTK_STATE_NORMAL] = green;
		// style->font = gdk_font_load("10x20");
		gtk_entry_set_text (GTK_ENTRY (status), "Idle.");
		gtk_widget_set_style (GTK_WIDGET (status), style);
	}
	//check if we should start recording
	if (record == 1)
	{
		on_start_clicked ((GtkButton *) widget, widget);
		record = 0;
	}
	g_list_free (vid_lst);
	g_list_free (aud_lst);
	g_list_free (mix_lst);
}





//set the FPS on norm change
void on_norm_val_changed (GtkEditable * editable, gpointer user_data)
{
	gchar norm_val[250];
	//gchar fps_val[250];
	GtkWidget *norm = lookup_widget (GTK_WIDGET (editable), "norm_val");
	GtkWidget *fps = lookup_widget (GTK_WIDGET (editable), "fps_val");
	strncpy (norm_val, gtk_entry_get_text (GTK_ENTRY (norm)), 250);
	//strncpy (fps_val, gtk_entry_get_text (GTK_ENTRY (fps)), 250);

	//set the fps value
	if (strcmp (norm_val, "NTSC") == 0 || strcmp (norm_val, "NTSC-JP") == 0)
		gtk_entry_set_text (GTK_ENTRY (fps), "29.970");
	else if (strstr (norm_val, "PAL") || strstr (norm_val, "SECAM"))
		gtk_entry_set_text (GTK_ENTRY (fps), "25");
}





//get new recording sources on mixer change
void on_amix_val_changed (GtkEditable * editable, gpointer user_data)
{
	#include <stdio.h>
	#include <string.h>
	#include <fcntl.h>
	#include <sys/ioctl.h>
	#include <sys/soundcard.h>
	
	gchar amix_val[250] = "";
	GList *arec_lst = NULL;

	char *dname[SOUND_MIXER_NRDEVICES] = SOUND_DEVICE_NAMES;
	int recmask = 0, recsrc = 0;
	int mixer_fd;
	int i = 0;

	GtkWidget *arec = lookup_widget (GTK_WIDGET (editable), "arec_val");
	GtkWidget *amix = lookup_widget (GTK_WIDGET (editable), "amix_val");
	GtkWidget *arec_cbo = lookup_widget (GTK_WIDGET (editable), "arec_cbo");
	strncpy (amix_val, gtk_entry_get_text (GTK_ENTRY (amix)), 250);

	if ((mixer_fd = open (amix_val, O_RDWR)) < 0)
	{
		arec_lst = g_list_append (arec_lst, "");
		gtk_combo_set_popdown_strings (GTK_COMBO (arec_cbo), arec_lst);
	}
	else
	{
		if (ioctl (mixer_fd, SOUND_MIXER_READ_RECMASK, &recmask) == -1)
		{
			arec_lst = g_list_append (arec_lst, "");
			gtk_combo_set_popdown_strings (GTK_COMBO (arec_cbo), arec_lst);
		}
		else
		{
			ioctl (mixer_fd, SOUND_MIXER_READ_RECMASK, &recmask);
			for (i = 0; i < SOUND_MIXER_NRDEVICES; i++)
				if ((1 << i) & recmask)
					arec_lst = g_list_append (arec_lst, dname[i]);
			gtk_combo_set_popdown_strings (GTK_COMBO (arec_cbo), arec_lst);
			if (strcmp (arec_val, "") != 0)
				gtk_entry_set_text (GTK_ENTRY (arec), arec_val);
			else
			{
				ioctl (mixer_fd, SOUND_MIXER_READ_RECSRC, &recsrc);
				for (i = 0; i < SOUND_MIXER_NRDEVICES; i++)
				if ((1 << i) & recsrc)
					gtk_entry_set_text (GTK_ENTRY (arec), dname[i]);
			}
		}
		close (mixer_fd);
	}

	g_list_free (arec_lst);
}





//set the recording source
void rec_src_set (GtkEditable * editable, gpointer user_data)
{
	#include <stdio.h>
	#include <string.h>
	#include <fcntl.h>
	#include <sys/ioctl.h>
	#include <sys/soundcard.h>

	gchar amix_val[250] = "";

	char *dname[SOUND_MIXER_NRDEVICES] = SOUND_DEVICE_NAMES;
	int recmask = 0, recsrc = 0;
	int mixer_fd;
	int i = 0;

	GtkWidget *arec = lookup_widget (GTK_WIDGET (editable), "arec_val");
	GtkWidget *amix = lookup_widget (GTK_WIDGET (editable), "amix_val");

	strncpy (amix_val, gtk_entry_get_text (GTK_ENTRY (amix)), 250);
	strncpy (arec_val, gtk_entry_get_text (GTK_ENTRY (arec)), 250);

	if ((mixer_fd = open (amix_val, O_RDWR)) < 0)
		strcpy (amix_val, "");
	else
	{
		ioctl (mixer_fd, SOUND_MIXER_READ_RECMASK, &recmask);
		ioctl (mixer_fd, SOUND_MIXER_READ_RECSRC, &recsrc);
		for (i = 0; i < SOUND_MIXER_NRDEVICES && strcmp (dname[i], arec_val); i++)
			if ((1 << (i + 1)) & recmask)
			{
				recsrc = (1 << (i + 1));
				ioctl (mixer_fd, SOUND_MIXER_WRITE_RECSRC, &recsrc);
			}
		close (mixer_fd);
	}
}





//automatic file extension function
gboolean on_combo_entry1_focus_out_event (GtkWidget * widget,
											GdkEventFocus * event, gpointer user_data)
{
	gchar file_val[250], tmp_file[250], cod_val[250], *noext, *ext, *pos, notilde[250], extn[5];
	gint i;
	gchar home[250];
	FILE *inFile;

	//lookup and store values
	GtkWidget *file = lookup_widget (GTK_WIDGET (widget), "file_val");
	GtkWidget *cod = lookup_widget (GTK_WIDGET (widget), "combo_entry1");
	strncpy (cod_val, gtk_entry_get_text (GTK_ENTRY (cod)), 250);
	strncpy (file_val, gtk_entry_get_text (GTK_ENTRY (file)), 250);

	strcpy (home, g_get_home_dir ());	//copy home dir value
	//check for "~"
	if (strchr (file_val, '~'))
	{
		strcpy (notilde, file_val);
		strcpy (file_val, home);
		strcat (file_val, "/");
		noext = strstr (notilde, "~");
		strncpy (noext, ".", 1);
		strcat (file_val, noext);
		gtk_entry_set_text (GTK_ENTRY (file), file_val);
	}


	//if no file set to untitled
	if (strlen (file_val) == 0)
	{
		strcpy (file_val, home);
		strcat (file_val, "/videos/untitled");
	}

	//put .avi extension if there's no "."
	if (strrchr (file_val, '.') == NULL)
	{
		strcat (file_val, ".avi");
		gtk_entry_set_text (GTK_ENTRY (file), file_val);
	}


	//put .avi if there's unknown extension
	if (strstr (file_val, ".avi") == NULL && strstr (file_val, ".mpg") == NULL)
	{
		strcat (file_val, ".avi");
		gtk_entry_set_text (GTK_ENTRY (file), file_val);
	}

	//get the filename only and see where the last "." in the name is
	ext = strrchr (file_val, '/');
	ext = strrchr (file_val, '.');

	//check if the thing we got is a 3 char extension
	if (strlen (ext) != 4)
	{
		//put a name if there's none
		if (strlen (ext) == 0)
			strcat (file_val, "untitled");
		strcat (file_val, ".avi");
		gtk_entry_set_text (GTK_ENTRY (file), file_val);
		ext = strrchr (file_val, '/');
		ext = strrchr (file_val, '.');
	}


	//if codec is not mpeg and we got .mpg put .avi
	if (strcmp (cod_val, "mpeg1") != 0 && strcmp (ext, ".mpg") == 0)
	{
		noext = strstr (file_val, ".mpg");
		strncpy (noext, ".avi", 4);
		gtk_entry_set_text (GTK_ENTRY (file), file_val);
		//return 0;
	}
	//do nothing if we got the right one
	else if (strcmp (cod_val, "mpeg1") != 0 && strcmp (ext, ".avi") == 0);

	//if we got other codec put .avi
	else if (strcmp (cod_val, "mpeg1") != 0)
	{
		strncpy (file_val, ".avi", 4);
		gtk_entry_set_text (GTK_ENTRY (file), file_val);
		//return 0;
	}

	//if we got mpeg w/ .avi put .mpg
	else if (strcmp (cod_val, "mpeg1") == 0 && strcmp (ext, ".avi") == 0)
	{
		noext = strstr (file_val, ".avi");
		strncpy (noext, ".mpg", 4);
		gtk_entry_set_text (GTK_ENTRY (file), file_val);
		//return 0;
	}
	//do nothing if we got the right ext for mpeg
	else if (strcmp (cod_val, "mpeg1") == 0 && strcmp (ext, ".mpg") == 0);

	//if we got .mpg for anything else, put .avi instead
	else if (strcmp (ext, ".mpg") == 0)
	{
		noext = strstr (file_val, ".mpg");
		strncpy (noext, ".avi", 4);
		gtk_entry_set_text (GTK_ENTRY (file), file_val);
		//return 0;
	}

	//resume recording or not
	if (resume == 0)
	{
		if ((inFile = fopen (file_val, "r")))
		{
			fclose (inFile);
			strcpy (notilde, file_val);
			pos = strrchr (notilde, '.');
			strcpy (extn, pos);
			extn[4] = '\0';
			if (strrchr (notilde, '-') && isdigit (*(pos - 1)))
				pos = strrchr (notilde, '-');
			strncpy (pos, "\0", 1);
			for (i = 1; i < 10000; i++)
			{
				sprintf (tmp_file, "%s-%d%s\0", notilde, i, extn);
			
				if ((inFile = fopen (tmp_file, "r")) == NULL)
				{
					strcpy (file_val, tmp_file);
					i = 10000;
				}
				else
					fclose (inFile);
			}
			gtk_entry_set_text (GTK_ENTRY (file), file_val);
			return 0;
		}
	}

	return FALSE;
}





//play file function
void on_play_clicked (GtkButton * button, gpointer user_data)
{
	//define variables
	FILE *inFile;
	gchar file_val[250];
	gchar player[250];
	gchar command[250];
	//lookup widget
	GtkWidget *file = lookup_widget (GTK_WIDGET (button), "file_val");
	GtkWidget *vid_player = lookup_widget (GTK_WIDGET (pref), "vid_player");
	strncpy (file_val, gtk_entry_get_text (GTK_ENTRY (file)), 250);
	strncpy (player, gtk_entry_get_text (GTK_ENTRY (vid_player)), 250);

	//see what player we got selected
	/*inFile = fopen ("/tmp/player-gv4l", "r");
	fscanf (inFile, "%s", player);
	fclose (inFile);
	*/
	//start player if there's one set
//	if (strcmp (player, "none") != 0 || fopen (player, "r") != NULL)
	if (strlen (player))
	{
		strcpy (command, player);
		strcat (command, " \"");
		strcat (command, file_val);
		strcat (command, "\"&");
		system (command);
	}
	else	//if no player popup selection dialog
	{
		GtkWidget *noplay;
		noplay = create_noplay ();
		gtk_widget_show (noplay);
		gtk_window_set_transient_for (GTK_WINDOW (noplay), GTK_WINDOW (gv4l));
		//exit;
	}
}

//call the play file function from menu
void on_play_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	on_play_clicked ((GtkButton *) menuitem, menuitem);
}



//select player activated
void on_select_player_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	on_preferences_activate ((GtkMenuItem *)menuitem, menuitem);
}



//save settings to file
void on_save_settings1_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	//define variables
	FILE *outFile;
	FILE *inFile;
	//gchar player[250] = "none";

	gchar vdev_val[250];
	gchar adev_val[250];
	gchar p_size[250];
	gchar fps_val[250];
	gchar src_val[250];
	gchar cod_val[250];
	gchar chan_val[250];
	gchar file_val[250];
	gchar vbit_val[250];
	gchar abit_val[250];
	gchar agn_val[250];
	gchar norm_val[10];
	gchar amix_val[250];
	gboolean prev_val;
	gchar rec_dur[250];
	gboolean deinter;
	gboolean yuv_val;

	//lookup widgets
	GtkWidget *vdev = lookup_widget (GTK_WIDGET (menuitem), "vdev_val");
	GtkWidget *adev = lookup_widget (GTK_WIDGET (menuitem), "adev_val");
	GtkWidget *size = lookup_widget (GTK_WIDGET (menuitem), "p_size");
	GtkWidget *fps = lookup_widget (GTK_WIDGET (menuitem), "fps_val");
	GtkWidget *cod = lookup_widget (GTK_WIDGET (menuitem), "combo_entry1");
	GtkWidget *src = lookup_widget (GTK_WIDGET (menuitem), "src_val");
	GtkWidget *chan = lookup_widget (GTK_WIDGET (menuitem), "chan_val");
	GtkWidget *file = lookup_widget (GTK_WIDGET (menuitem), "file_val");
	GtkWidget *vbit = lookup_widget (GTK_WIDGET (menuitem), "vbit_val");
	GtkWidget *abit = lookup_widget (GTK_WIDGET (menuitem), "abit_val");
	GtkWidget *agn = lookup_widget (GTK_WIDGET (menuitem), "agn_val");
	GtkWidget *prev = lookup_widget (GTK_WIDGET (menuitem), "prev_val");
	GtkWidget *rec = lookup_widget (GTK_WIDGET (menuitem), "recTime");
	GtkWidget *inter = lookup_widget (GTK_WIDGET (menuitem), "de_inter");
	GtkWidget *yuv = lookup_widget (GTK_WIDGET (menuitem), "yuv_val");
	GtkWidget *norm = lookup_widget (GTK_WIDGET (menuitem), "norm_val");
	GtkWidget *amix = lookup_widget (GTK_WIDGET (menuitem), "amix_val");
	GtkWidget *arec = lookup_widget (GTK_WIDGET (menuitem), "arec_val");

	//read values
	strncpy (vdev_val, gtk_entry_get_text (GTK_ENTRY (vdev)), 250);
	strncpy (adev_val, gtk_entry_get_text (GTK_ENTRY (adev)), 250);
	strncpy (p_size, gtk_entry_get_text (GTK_ENTRY (size)), 250);
	strncpy (fps_val, gtk_entry_get_text (GTK_ENTRY (fps)), 250);
	strncpy (cod_val, gtk_entry_get_text (GTK_ENTRY (cod)), 250);
	strncpy (src_val, gtk_entry_get_text (GTK_ENTRY (src)), 250);
	strncpy (chan_val, gtk_entry_get_text (GTK_ENTRY (chan)), 250);
	strncpy (file_val, gtk_entry_get_text (GTK_ENTRY (file)), 250);
	strncpy (vbit_val, gtk_entry_get_text (GTK_ENTRY (vbit)), 250);
	strncpy (abit_val, gtk_entry_get_text (GTK_ENTRY (abit)), 250);
	strncpy (agn_val, gtk_entry_get_text (GTK_ENTRY (agn)), 250);
	strncpy (rec_dur, gtk_entry_get_text (GTK_ENTRY (rec)), 250);
	strncpy (norm_val, gtk_entry_get_text (GTK_ENTRY (norm)), 10);
	strncpy (amix_val, gtk_entry_get_text (GTK_ENTRY (amix)), 250);
	strncpy (arec_val, gtk_entry_get_text (GTK_ENTRY (arec)), 250);
	deinter = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (inter));
	prev_val = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (prev));
	yuv_val = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (yuv));


	//write config file
	outFile = fopen (config_file, "w");
	fprintf (outFile,
		 "[Default=Gv4l]\n\nVideoDev=%s\nAudioDev=%s\nPicSize=%s\nFPS=%s\nCodec=%s\nVBitrate=%s\nABitrate=%s\nAGain=%s\nSource=%s\nChannel=%s\nFile=%s\nPreview=%s\nDeInter=%s\nDuration=%s\nYuv=%s\nStandard=%s\nMixer=%s\nAudioSrc=%s\n\nScreenSaver=%d\nResume=%d\nSaveOnExit=%d\n\n[End Gv4l]\n\n",
		 vdev_val, adev_val, p_size, fps_val, cod_val, vbit_val, abit_val,
		 agn_val, src_val, chan_val, file_val, prev_val == TRUE ? "1" : "0",
		 deinter == TRUE ? "1" : "0", rec_dur,
		 yuv_val == TRUE ? "1" : "0", norm_val, amix_val, arec_val,
		 scrsaver, resume, save_exit);
	fclose (outFile);
}





//load program default settings
void on_revert_to_defaults1_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	char config[250];		//config file

	gchar status_val[250] = "";
	GtkWidget *status = lookup_widget (GTK_WIDGET (menuitem), "status");
	strncpy (status_val, gtk_entry_get_text (GTK_ENTRY (status)), 250);
	if (strcmp (status_val, "Idle.") != 0)
	{
		GtkWidget *unsafe;
		unsafe = create_unsafe ();
		gtk_widget_show (unsafe);
		gtk_window_set_transient_for (GTK_WINDOW (unsafe), GTK_WINDOW (gv4l));
	}
	else
	{
		//store config file to other variable
		strcpy (config, config_file);
		//remove config file value
		strcpy (config_file, "");
		//run program init function
		on_gv4l_show ((GtkWidget *) menuitem, menuitem);
		//restore config file value
		strcpy (config_file, config);
	}
}





//reload the settings from file
void on_reload_saved_settings1_activate (GtkMenuItem * menuitem,
											gpointer user_data)
{
	gchar status_val[250] = "";
	GtkWidget *status = lookup_widget (GTK_WIDGET (menuitem), "status");
	strncpy (status_val, gtk_entry_get_text (GTK_ENTRY (status)), 250);
	if (strcmp (status_val, "Idle.") != 0)
	{
		GtkWidget *unsafe;
		unsafe = create_unsafe ();
		gtk_widget_show (unsafe);
		gtk_window_set_transient_for (GTK_WINDOW (unsafe), GTK_WINDOW (gv4l));
	}
	else
		on_gv4l_show ((GtkWidget *) menuitem, menuitem);
}





//show about box
void on_about_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	GtkWidget *about;
	about = create_about ();
	gtk_widget_show (about);
}





//program exit
gboolean
on_gv4l_delete_event (GtkWidget * widget,
						GdkEvent * event, gpointer user_data)
{
	//stop transcode if running
	system ("killall -2 transcode 2>/dev/null");
	system ("killall -9 gv4l-sleep.sh 2>/dev/null");
	//remove temporary files
	system ("rm -rf /tmp/gv4l*");
	system ("rm -rf /tmp/player-gv4l");
	system ("rm -rf /tmp/trr /tmp/tr-out*");
	// Remove leftovers from DivX5 because of possible permissions problems
	// Explanations at http://www.theorie.physik.uni-goettingen.de/pipermail/transcode-users/2002-May/002291.html
	system ("rm -rf \"c:\\trace_b.txt\"");
	//re-enable screensaver if disabled by Gv4l
	if (scrsaver == 0)
		system ("xscreensaver -no-splash >/dev/null 2>&1 &");
	//save settings?
	if (save_exit == 1)
		on_save_settings1_activate ((GtkMenuItem *) widget, widget);
	//exit
	on_btnClose_clicked ((GtkButton *) widget, widget);
	gtk_exit (0);
	return 1;
}


//program exit
void on_exit1_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	//stop transcode if running
	system ("killall -2 transcode 2>/dev/null");
	system ("killall -9 gv4l-sleep.sh 2>/dev/null");
	//remove temporary files
	system ("rm -rf /tmp/gv4l*");
	system ("rm -rf /tmp/player-gv4l");
	system ("rm -rf /tmp/trr /tmp/tr-out*");
	// Remove leftovers from DivX5 because of possible permissions problems
	// Explanations at http://www.theorie.physik.uni-goettingen.de/pipermail/transcode-users/2002-May/002291.html
	system ("rm -rf \"c:\\trace_b.txt\"");
	//re-enable screensaver if disabled by Gv4l
	if (scrsaver == 0)
		system ("xscreensaver -no-splash >/dev/null 2>&1 &");
	//save settings?
	if (save_exit == 1)
		on_save_settings1_activate ((GtkMenuItem *) menuitem, menuitem);
	//exit
	on_btnClose_clicked ((GtkButton *) menuitem, menuitem);
	gtk_exit (0);
}


//program exit
void on_exit_no_tr_clicked (GtkButton * button, gpointer user_data)
{
	//stop transcode if running
	system ("killall -2 transcode 2>/dev/null");
	system ("killall -9 gv4l-sleep.sh 2>/dev/null");
	//remove temporary files
	system ("rm -rf /tmp/gv4l*");
	system ("rm -rf /tmp/player-gv4l");
	system ("rm -rf /tmp/trr /tmp/tr-out*");
	// Remove leftovers from DivX5 because of possible permissions problems
	// Explanations at http://www.theorie.physik.uni-goettingen.de/pipermail/transcode-users/2002-May/002291.html
	system ("rm -rf \"c:\\trace_b.txt\"");
	//re-enable screensaver if disabled by Gv4l
	if (scrsaver == 0)
		system ("xscreensaver -no-splash >/dev/null 2>&1 &");
	//exit
	on_btnClose_clicked ((GtkButton *) button, button);
	gtk_exit (1);
}


//read & set the v4l recording source(s)
void on_vdev_val_changed (GtkEditable * editable, gpointer user_data)
{
	struct video_capability cap;
	struct video_channel chan;
	int v4l_fd, i = 0;
	gchar vdev_val[250] = "";
	gchar src_val[10][250];

	GtkWidget *vdev = lookup_widget (GTK_WIDGET (editable), "vdev_val");
	GtkWidget *src = lookup_widget (GTK_WIDGET (editable), "src_val");
	GtkWidget *src_cbo = lookup_widget (GTK_WIDGET (editable), "src_cbo");
	GList *src_lst = NULL, *none = NULL;

	gtk_entry_set_text (GTK_ENTRY (src), "");
	none = g_list_append (none, "");
	gtk_combo_set_popdown_strings (GTK_COMBO (src_cbo), none);

	strncpy (vdev_val, gtk_entry_get_text (GTK_ENTRY (vdev)), 250);
	v4l_fd = open (vdev_val, O_RDONLY);
	ioctl (v4l_fd, VIDIOCGCHAN, &chan);
	ioctl (v4l_fd, VIDIOCGCAP, &cap);

	for (i = 0; i < cap.channels; i++)
	{
		memset (&chan, 0, sizeof (chan));
		chan.channel = i;
		if (-1 == ioctl (v4l_fd, VIDIOCGCHAN, &chan))
			break;
		sprintf (src_val[i], "%s", &chan.name);
		src_lst = g_list_append (src_lst, src_val[i]);
		gtk_combo_set_popdown_strings (GTK_COMBO (src_cbo), src_lst);
	}
	close (v4l_fd);
	g_list_free (src_lst);
}


//get the v4l device info
void get_v4l_info (char v4l_dev[250], int v4l_id)
{
	struct video_capability cap;
	struct video_channel chan;
	int v4l_fd, i = 0;

	v4l_fd = open (v4l_dev, O_RDONLY);
	ioctl (v4l_fd, VIDIOCGCHAN, &chan);
	ioctl (v4l_fd, VIDIOCGCAP, &cap);

	sprintf (v4l_info[v4l_id], "%s=%s, ", v4l_dev, &cap.name);
	for (i = 0; i < cap.channels; i++)
	{
		memset (&chan, 0, sizeof (chan));
		chan.channel = i;
		if (-1 == ioctl (v4l_fd, VIDIOCGCHAN, &chan))
			break;
		sprintf (v4l_info[v4l_id], "%s%d=%s, ", v4l_info[v4l_id], i,
				 &chan.name);
	}
	//printf ("%s\n", v4l_info[v4l_id]);
	close (v4l_fd);
}


//change the TV norm (standard)
void set_norm (char v4l_dev[250], char norm[20])
{
	struct video_capability cap;
	struct video_channel chan;
	int v4l_fd, i = 0;

	v4l_fd = open (v4l_dev, O_RDONLY);
	ioctl (v4l_fd, VIDIOCGCHAN, &chan);
	ioctl (v4l_fd, VIDIOCGCAP, &cap);

	for (i = 0; i < cap.channels; i++)
	{
		memset (&chan, 0, sizeof (chan));
		chan.channel = i;
		if (strcmp (norm, "NTSC") == 0)
			chan.norm = VIDEO_MODE_NTSC;
		else if (strcmp (norm, "PAL") == 0)
			chan.norm = VIDEO_MODE_PAL;
		else if (strcmp (norm, "SECAM") == 0)
			chan.norm = VIDEO_MODE_SECAM;
		else if (strcmp (norm, "PAL-Nc") == 0)
			chan.norm = VIDEO_MODE_PAL_Nc;
		else if (strcmp (norm, "PAL-M") == 0)
			chan.norm = VIDEO_MODE_PAL_M;
		else if (strcmp (norm, "PAL-N") == 0)
			chan.norm = VIDEO_MODE_PAL_N;
		else if (strcmp (norm, "NTSC-JP") == 0)
			chan.norm = VIDEO_MODE_NTSC_JP;
		else if (strcmp (norm, "PAL-60") == 0)
			chan.norm = VIDEO_MODE_PAL_60;
		else if (strcmp (norm, "Current") == 0)
			break;
		ioctl (v4l_fd, VIDIOCSCHAN, &chan);

		if (-1 == ioctl (v4l_fd, VIDIOCGCHAN, &chan))
			break;
	}
	close (v4l_fd);
}


void on_preferences_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	GtkWidget *scrsav = lookup_widget (pref, "scrsaver");
	GtkWidget *res = lookup_widget (pref, "resume");
	GtkWidget *sav = lookup_widget (pref, "save_conf");
	GtkWidget *player = lookup_widget (pref, "vid_player");
	GtkWidget *split = lookup_widget (pref, "split_val");
	strcpy (temp, gtk_entry_get_text (GTK_ENTRY (player)));
	strcpy (temp1, gtk_entry_get_text (GTK_ENTRY (split)));
	gtk_widget_show (pref);
	gtk_window_set_transient_for (GTK_WINDOW (pref), GTK_WINDOW (gv4l));
	//gtk_window_set_decorated (gtk_widget_get_root_window (pref), TRUE);

	if (scrsaver == 0)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (scrsav), TRUE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (scrsav), FALSE);
	if (resume == 1)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (res), TRUE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (res), FALSE);
	if (save_exit == 1)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sav), TRUE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sav), FALSE);
}

gboolean on_pref_delete_event (GtkWidget * widget,
								GdkEvent * event, gpointer user_data)
{
	on_pref_stop_clicked (NULL, NULL);
	//return FALSE;
}


void on_pref_stop_clicked (GtkButton * button, gpointer user_data)
{
	GtkWidget *player = lookup_widget (pref, "vid_player");
	GtkWidget *split = lookup_widget (pref, "split_val");
	gtk_entry_set_text (GTK_ENTRY (player), temp);
	gtk_entry_set_text (GTK_ENTRY (split), temp1);
	temp[0] = '\0';
	temp1[0] = '\0';
	gtk_widget_hide (pref);
}


void on_pref_apply_clicked (GtkButton * button, gpointer user_data)
{
	GtkWidget *scrsav = lookup_widget (pref, "scrsaver");
	GtkWidget *res = lookup_widget (pref, "resume");
	GtkWidget *sav = lookup_widget (pref, "save_conf");
	GtkWidget *split = lookup_widget (pref, "split_val");
	GtkWidget *player = lookup_widget (pref, "vid_player");
	gchar split_val[10] = "";
	gchar player_val[250] = "";
	gboolean scrsav_val = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (scrsav));
	gboolean resume_val = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (res));
	gboolean save_val = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (sav));

	FILE *inFile;
	FILE *outFile;
	gchar config_file_old[250], conf_line[250];
	gint found[5] = { 0, 0, 0, 0, 0 };

	strcpy (split_val, gtk_entry_get_text (GTK_ENTRY (split)));
	strcpy (player_val, gtk_entry_get_text (GTK_ENTRY (player)));
	
	if (scrsav_val == TRUE && scrsaver == 1)
		system ("xscreensaver-command -exit >/dev/null 2>&1 &");
	else if (scrsav_val != TRUE && scrsaver == 0)
		system ("xscreensaver -no-splash >/dev/null 2>&1 &");
	scrsaver = (scrsav_val == TRUE ? 0 : 1);
	resume = (resume_val == TRUE ? 1 : 0);
	save_exit = (save_val == TRUE ? 1 : 0);
	sprintf (config_file_old, "%s.old", config_file);
	rename (config_file, config_file_old);
	inFile = fopen (config_file_old, "r");
	outFile = fopen (config_file, "w");
	for (;;)
	{
		int i = 0;

		fgets (conf_line, 250, inFile);
		if (feof (inFile))
			break;
		if (strstr (conf_line, "ScreenSaver="))
		{
			fprintf (outFile, "ScreenSaver=%d\n", scrsaver);
			found[0] = 1;
		}
		else if (strstr (conf_line, "Resume="))
		{
			fprintf (outFile, "Resume=%d\n", resume);
			found[1] = 1;
		}
		else if (strstr (conf_line, "SaveOnExit="))
		{
			fprintf (outFile, "SaveOnExit=%d\n", save_exit);
			found[2] = 1;
		}
		else if (strstr (conf_line, "Split="))
		{
			fprintf (outFile, "Split=%s\n", split_val);
			found[3] = 1;
		}
		else if (strstr (conf_line, "Player="))
		{
			fprintf (outFile, "Player=%s\n", player_val);
			found[4] = 1;
		}
		else if (strstr (conf_line, "[End Gv4l]"))
		{
			if (found[0] == 0)
				fprintf (outFile, "ScreenSaver=%d\n", scrsaver);
			if (found[1] == 0)
				fprintf (outFile, "Resume=%d\n", resume);
			if (found[2] == 0)
				fprintf (outFile, "SaveOnExit=%d\n", save_exit);
			if (found[3] == 0)
				fprintf (outFile, "Split=%s\n", split_val);
			if (found[4] == 0)
				fprintf (outFile, "Player=%s\n\n", player_val);
			fprintf (outFile, "%s", conf_line);
		}
		else
			fprintf (outFile, "%s", conf_line);
	}
	fclose (inFile);
	fclose (outFile);
	unlink (config_file_old);
	gtk_widget_hide (pref);
	temp[0] = '\0';
	temp1[0] = '\0';
}

void on_chan_val_changed	(GtkEditable *editable,
								gpointer user_data)
{
	GtkWidget *status = lookup_widget (GTK_WIDGET (editable), "status");
	GtkWidget *chan = lookup_widget (GTK_WIDGET (editable), "chan_val");
	//only restart if in watch mode and avoid double start
	if (strstr (gtk_entry_get_text (GTK_ENTRY (status)), "Playing") &&
		strlen (gtk_entry_get_text (GTK_ENTRY (chan))))
		on_watch_clicked ((GtkButton *) editable, editable);
}


void on_src_val_changed		(GtkEditable *editable,
								gpointer user_data)
{
	GtkWidget *src = lookup_widget (GTK_WIDGET (editable), "src_val");
	if (strlen (gtk_entry_get_text (GTK_ENTRY (src))))
		on_chan_val_changed ((GtkEditable *) editable, editable);
}
