/*
 * Gv4l's main stuff
 * Command Line params, check for transcode functions
 * 
 * Author:	Todor T. Zviskov (a.k.a. Warder) - http://warder.ath.cx:81/
 * License:	GPL-2 - http://www.gnu.org/licenses/gpl.txt
 *
 * (C)2002-2004 Todor T. Zviskov.
 */


#ifdef HAVE_CONFIG_H
	#include <config.h>
#endif

#include <gnome.h>

#include "interface.h"
#include "support.h"
GtkWidget *gv4l;		//should be global if we want to look up widgets
GtkWidget *pref;		//prefs window

gchar config_file[250];		//configuration file variable
gboolean record = 0;		//record on startup var



int main (int argc, char *argv[])
{
	//transcode vesrion verification variables
	FILE *tr;
	gchar result[250];
	gint v, p, s;
	int i;			//counter

	#ifdef ENABLE_NLS
		bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
		bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
		textdomain (GETTEXT_PACKAGE);
	#endif

	//set the gefault config file
	strcpy (config_file, g_get_home_dir ());
	strcat (config_file, "/.gv4l2/config");

	//check if we have any arguments
	if (argc <= 1)
		gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE, argc, argv,
							GNOME_PARAM_APP_DATADIR, PACKAGE_DATA_DIR, NULL);
	else
	{
		for (i = 1; i < argc; i++)	//see what arguments we have
		{
			//append --file and --record help
			if (strcmp (argv[i], "--help") == 0 || strcmp (argv[i], "-?") == 0
				|| strcmp (argv[i], "--usage") == 0)
			{
				printf ("\nGv4l Options\n");
				printf ("\n	gv4l --file /path/to/config/filename    Use another configuration file");
				printf ("\n	     --record                           Start recording on startup\n\n\n");
				gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE, argc,
									argv, GNOME_PARAM_APP_DATADIR,
									PACKAGE_DATA_DIR, NULL);
				exit (0);
			}
			//check for --record and --file
			else if (strcmp (argv[i], "--file") == 0
					|| strcmp (argv[i], "--record") == 0)
			{
				if (strcmp (argv[i], "--file") == 0 && argv[i + 1] != NULL)
				{
					//can't read the file
					if (fopen (argv[i + 1], "r") == NULL)
					{
						printf ("Unable to read the specified file, using the default one (if exists).\n\n");
						strcpy (config_file, g_get_home_dir ());
						strcat (config_file, "/.gv4l2/config");
						strcpy (argv[i], "");
						gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE,
											argc, argv,
											GNOME_PARAM_APP_DATADIR,
											PACKAGE_DATA_DIR, NULL);
					}
					//set the custom config file
					else
					{
						printf ("Using \"%s\" as a configuration file\n\n", argv[i + 1]);
						strcpy (config_file, argv[i + 1]);
						strcpy (argv[i], "");
						strcpy (argv[i + 1], "");
						if (argv[i + 2] == NULL)
						{
							gnome_program_init (PACKAGE, VERSION,
												LIBGNOMEUI_MODULE, argc, argv,
												GNOME_PARAM_APP_DATADIR,
												PACKAGE_DATA_DIR, NULL);
							i = argc;	//break the for loop
						}
					}
				}
				//don't have --file value
				else if (strcmp (argv[i], "--file") == 0 && argv[i + 1] == NULL)
				{
					printf ("\nOption \"--file\" specified without value\n");
					exit (1);
				}
				//start recording on startup
				else if (strcmp (argv[i], "--record") == 0)
				{
					record = 1;
					strcpy (argv[i], "");
					if (argv[i + 1] == NULL)
					{
						gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE,
											argc, argv,
											GNOME_PARAM_APP_DATADIR,
											PACKAGE_DATA_DIR, NULL);
						i = argc;	//break the for loop
					}
				}
			}
			//don't have known arguments, continue
			else if (i + 1 == argc)
				gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE,
									argc, argv,
									GNOME_PARAM_APP_DATADIR, PACKAGE_DATA_DIR,
									NULL);
		}
	}



	/*
	 * The following code was added by Glade to create one of each component
	 * (except popup menus), just so that you see something after building
	 * the project. Delete any components that you don't want shown initially.
	 */

	pref = create_pref ();

	gv4l = create_gv4l ();
	gtk_widget_show (gv4l);

	//extract transcode's version
	system
		("rm -rf /tmp/gv4l-tr* && transcode -v > /tmp/gv4l-tr 2>>/tmp/gv4l-tr || echo -1.-1.0 > /tmp/gv4l-tr && cat /tmp/gv4l-tr|cut -d \"v\" -f2|cut -d \" \" -f1 >/tmp/gv4l-transcode && rm -rf /tmp/gv4l-tr");

	tr = fopen ("/tmp/gv4l-transcode", "r");
	fscanf (tr, "%s", result);
	fclose (tr);
	system ("rm -rf /tmp/gv4l-tr*");
	sscanf (result, "%d.%d.%d", &v, &p, &s);
	//see if we have any transcode
	if (v == -1 && p == -1)
	{
		GtkWidget *no_transcode;
		no_transcode = create_no_transcode ();
		gtk_widget_show (no_transcode);
		gtk_widget_hide (gv4l);
		exit;
	}
	//see if transcode>=0.6.7
	else if (v < 1 && p <= 6 && s < 7)
	{
		GtkWidget *no_transcode1;
		no_transcode1 = create_no_transcode1 ();
		gtk_widget_show (no_transcode1);
		gtk_widget_hide (gv4l);
		exit;
	}


	//continue loading
	gtk_main ();
	return 0;
}
